<script type="text/vbscript">
Option Explicit

Class Enroll
  Private Form
  Private DN

  Private Sub Class_Initialize()
    Set Form = Document.MyForm
  End Sub

  Public Sub FindProviders()
    Dim i, j, cspOption, csp, DefaultKeySize
    Const enumFlags = 0
    On Error Resume Next

    i = 0
    j = 1
    DefaultKeySize = 0
    cenroll.providerType = 1
    Do
      csp = ""
      csp = cenroll.enumProviders(i, enumFlags)
      If Len(csp) = 0 Then
        Exit Do
      End If
      set cspOption = document.createElement("option")
      cspOption.text = "512 bit, " & csp
      cspOption.value = "2" & csp
      Form.cspName.add(cspOption)
      If InStr(1, csp, "Enhanced", 1) Then
        j = j + 1
        DefaultKeySize = j
        Set cspOption = document.createElement("option")
        cspOption.text = "1024 bit, " & csp
        cspOption.value = "4" & csp
        Form.cspName.add(cspOption)
      End If
      i = i + 1
      j = j + 1
    Loop
    Form.cspName.selectedIndex = DefaultKeySize
  End Sub

  Private Function AddRDN(sn, value)
    Dim i, c
    AddRDN = False
    If value = "" Then
      Exit Function
    End If
    For i = 1 to Len(value)
      c = Mid(value, i, 1)
      If c = "," or c = "\" or c = "+" or c = ";" or Asc(c) > 125 or Asc(c) < 32 Then
        Exit Function
      End If
    Next
    If DN <> "" Then
      DN = DN & "; "
    End If
    DN = DN & sn & "=" & value
    AddRDN = True
  End Function

  Private Sub FieldErr(f)
    f.Focus
    Alert "Error: " & f.id & " is empty or illegal"
  End Sub

  Private Function MakeRDN()
    MakeRDN = False
    DN = ""
    If AddRDN("C", Form.country.value) = False Then
      Call FieldErr(Form.country)
      Exit Function
    End If
    If AddRDN("S", Form.state.value) = False Then
      Call FieldErr(Form.state)
      Exit Function
    End If
    If AddRDN("L", Form.locality.value) = False Then
      Call FieldErr(Form.locality)
      Exit Function
    End If
    If AddRDN("O", Form.organization.value) = False Then
      Call FieldErr(Form.organization)
      Exit Function
    End If
    If AddRDN("OU", Form.orgUnit.value) = False Then
      Call FieldErr(Form.orgUnitName)
      Exit Function
    End If
    If AddRDN("CN", Form.commonName.value) = False Then
      Call FieldErr(Form.commonName)
      Exit Function
    End If
    If AddRDN("E", Form.emailAddress.value) = False Then
      Call FieldErr(Form.emailAddress)
      Exit Function
    End If
    MakeRDN = True
  End Function

  Public Function CreateP10()
    Dim keyprov, key, prov, pkcs10data, GenKeyFlags
    Const CRYPT_EXPORTABLE=1
    Const CRYPT_USER_PROTECTED=2
    Const usage = ""
    CreateP10 = False
    If MakeRDN = False Then
      Exit Function
    End If
    keyprov = Form.cspName.value
    key = Mid(keyprov, 1, 1)
    prov = Mid(keyprov, 2)
    GenKeyFlags = key * &h01000000 + CRYPT_EXPORTABLE + CRYPT_USER_PROTECTED
    cenroll.providerType = 1
    cenroll.providerName = prov
    cenroll.GenKeyFlags = GenKeyFlags
    cenroll.HashAlgorithm = "MD5"
    cenroll.KeySpec = 1
    cenroll.EnableT61DNEncoding = True
    On Error Resume Next
    pkcs10data = cenroll.createPKCS10(DN, usage)
    If pkcs10data = Empty Then
      CreateP10 = False
      Alert "Error " & Hex(Err) & ": Your credentials could not be generated."
      Exit Function
    End If
    CreateP10 = True
    Form.CERTREQ.value = pkcs10data
    Form.submit()
  End Function


End Class

Dim myenroll
</script>